<template>
  <div class="mb-3">
    <label :for="id" v-if="field.label">
      {{ field.label }}
      <RequiredIcon v-if="isRequired" />
      <InfoTooltip v-if="field.tooltip" :text="field.tooltip" />
    </label>

    <div :id="id" ref="editorRef"></div>

    <input type="hidden" :id="fieldPrefix + field.name + '__hidden'" v-model="fieldValue" />

    <div class="text-danger" v-if="error">{{ error }}</div>

    <div style="display: none">
      <EmojiPopupContent :id="emojiPopupContentId" @click-emoji="onClickEmoji" />
      <ImagePopupContent
        :id="imagePopupContentId"
        @image-selector="onImageSelector"
        @insert="onImageInsert"
        @close="onImageClose"
      />
    </div>
  </div>
</template>

<script>
import { ref, computed, onMounted } from 'vue'

// TODO: Upgrade to v3
import Editor from '@toast-ui/editor'

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// TODO: Remove this dependency.
// import ImageHelper from '../gallery/src/lib/image-helper'
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

import EmojisHelper from '../../../lib/emojis/emojis-helper.js'
import { useVFormControl } from '../../../plugins/vform-plugin.js'
import InfoTooltip from '../../info-tooltip.vue'
import RequiredIcon from '../../required-icon.vue'
import EmojiPopupContent from './emoji-popup-content.vue'
import ImagePopupContent from './image-popup-content.vue'

import '@toast-ui/editor/dist/toastui-editor-only.css'

export default {
  name: 'VFormMarkdown',
  components: {
    InfoTooltip,
    RequiredIcon,
    EmojiPopupContent,
    ImagePopupContent,
  },
  emits: ['fieldInput', 'imageSelector'],
  props: {
    formName: { type: String, required: true },
    field: { type: Object, required: true },
    fieldPrefix: { type: String, required: true },
    modelState: { type: Object, default: null }, // Taken from the API response if validation fails at the server.
    busy: { type: Boolean, default: false },
  },
  setup(props, context) {
    const baseProperties = useVFormControl(props, context)

    const editorRef = ref(null)

    // Set in `mounted()`
    // const emojiButton = ref(undefined)
    // const emojiPopup = ref(undefined)
    // const imagePopup = ref(undefined)

    const id = computed(() => {
      return props.fieldPrefix + props.field.name
    })

    // const emojiPopupContentId = computed(() => {
    //   return id.value + '_emojiPopupContent'
    // })

    // const imagePopupContentId = computed(() => {
    //   return id.value + '_imagePopupContent'
    // })

    const onEditorChange = () => {
      // TODO: Use a WYSIWYG markdown editor that supports emojis.
      const rawValue = editorRef.value.getMarkdown(props.field.value)
      const value = EmojisHelper.unicodeToMarkdown(rawValue)

      const mutatedField = JSON.parse(JSON.stringify(props.field))
      mutatedField.value = value
      context.emit('fieldInput', mutatedField)
    }

    const onClickEmoji = (emoji) => {
      // TODO:  insert emoji.markdown instead.
      //
      //        We're doing this for now because Toast UI Editor is too hard to customise.
      //
      //        The plan is to wait until Toast UI Editor v3 is released.
      //        It looks like they're switching to ProseMirror for the WYSIWYG editor.
      //        see: https://github.com/nhn/tui.editor/issues/1253
      //
      //        ProseMirror has markdown support.
      //        see: https://prosemirror.net/examples/markdown/
      //
      //        For now, we'll just convert unicode emojis back to markdown when we update the form field value
      //        in `onEditorChange()` above.
      //
      editorRef.value.insertText(emoji.unicode)
    }

    const onImageSelector = () => {
      // Remove the editor so that the "Insert image" tooltip disappears.
      editorRef.value.remove()

      // Image selector is handled in the VForm component.
      context.emit('imageSelector', props.field)
    }

    // // onImageInsert(image) {
    // const onImageInsert = () => {
    //   // TODO: Insert image as markdown.
    // }

    // const onImageClose = () => {
    //   imagePopup.value.hide()
    // }

    /*
    const mountEmojiButton = () => {
      const button = document.createElement('button')
      button.innerHTML = `😀`
      button.className = 'emoji-button'
      return button
    }
    */

    const mountEditor = () => {
      /*
      const emojiToolbarItem = {
        type: 'button',
        options: {
          el: emojiButton.value,
          tooltip: 'Insert emoji',
        },
      }

      const imageToolbarItem = {
        type: 'button',
        options: {
          className: 'tui-image tui-toolbar-icons',
          tooltip: 'Insert image'
        }
      }
      */

      return new Editor({
        el: editorRef.value,
        usageStatistics: false,
        height: 'auto',
        minHeight: '100px',
        toolbarItems: [
          [
            // emojiToolbarItem,
            'heading',
            'bold',
            'italic',
            'strike',
          ],
          ['hr', 'quote'],
          ['ul', 'ol', 'task', 'indent', 'outdent'],
          [
            'table',
            'image',
            // imageToolbarItem,
            'link',
          ],
          ['code', 'codeblock'],
        ],
        initialValue: props.field.value,
        initialEditType: 'wysiwyg',
        events: {
          change: onEditorChange,
        },
        hideModeSwitch: true,
        customHTMLRenderer: {
          text(node) {
            return {
              type: 'text',
              content: EmojisHelper.markdownToUnicode(node.literal),
            }
          },
        },
      })
    }

    /*
    const mountEmojiPopup = () => {
      const ui = editorRef.value.getUI()
      const popup = ui.createPopup({
        header: true,
        title: 'Insert emoji',
        target: ui.el,
        content: document.querySelector(`#${emojiPopupContentId.value}`),
        openerCssQuery: ['.emoji-button'],
        closerCssQuery: ['.tui-editor-contents'],
      })
      const left = emojiButton.value.offsetLeft
      const top = emojiButton.value.offsetTop + emojiButton.value.offsetHeight
      popup.el.style = `display:none; position:absolute; left:${left}px; top:${top}px; width:auto; height:auto;`
      return popup
    }

    const mountImagePopup = () => {
      const ui = this.editor.getUI()
      const popup = ui.createPopup({
        header: true,
        title: 'Insert image',
        target: ui.el,
        content: document.querySelector(`#${this.imagePopupContentId}`),
        openerCssQuery: ['.tui-image'],
        closerCssQuery: ['.tui-editor-contents']
      })
      popup.el.className = [popup.el.className, 'tui-popup-wrapper te-popup-add-image tui-editor-popup'].join(' ')
      return popup
    }
    */

    /*
    const imageSelector = this.$store.state.gallery
    const returningFromImageSelector =
      this.$route.name === imageSelector.returnRoute.name &&
      JSON.stringify(this.$route.query) === JSON.stringify(imageSelector.returnRoute.query) &&
      JSON.stringify(this.$route.params) === JSON.stringify(imageSelector.returnRoute.params) &&
      this.formName === imageSelector.formName &&
      this.field.name === imageSelector.selectedField

    if (returningFromImageSelector) {
      const start = imageSelector.selectionStart
      const end = imageSelector.selectionEnd
      const selectedImages = imageSelector.selectedImages

      if (imageSelector.returnMode === 'select' && selectedImages.length > 0) {
        // const asThumb = true // TODO: make an option in image selector?
        // const insertMarkdown = ImageHelper.toMarkdown(this.storageBaseUrl, selectedImages, asThumb)
        const insertMarkdown = selectedImages

        this.field.value = StringHelper.insert(this.field.value, insertMarkdown, start, end)
      }

      // TODO: Restore selection based on start and end

      this.clearImageSelector()
    }
    */

    onMounted(() => {
      // emojiButton.value = mountEmojiButton()
      editorRef.value = mountEditor()
      // emojiPopup.value = mountEmojiPopup()
      // imagePopup.value = mountImagePopup()
    })

    return {
      ...baseProperties,
      editorRef,
      // emojiButton,
      // emojiPopup,
      // imagePopup,
      id,
      // emojiPopupContentId,
      // imagePopupContentId,
      onClickEmoji,
      onImageSelector,
      // onImageInsert,
      // onImageClose,
    }
  },
}
</script>

<style lang="scss">
.emoji-button {
  width: 20px !important; // actually 18px because of border-box.
  height: 20px !important;
  padding: 2px 0 0 0 !important;
  font-size: 16px;
  line-height: 16px;
  text-align: center;
}
</style>
